<?php
   /**
    * @file
    * KerberosInterface class definition.
    */
   class KerberosInterface
   {

      function KerberosInterface() {
         $this->realm = NULL;
      }

      var $realm;

      function setOption($option, $value) {
         switch ( $option ) {
            case 'realm':
               $this->realm = trim($value);
               break;
         }
      }

      function getOption($option) {
         $ret = '';
         switch ( $option ) {
            case 'realm':
               $ret = $this->realm;
               break;
         }
         return $ret;
      }

      /**
       * @param string $user username
       * @param string $pass password
       * @return string --array of tickets
       */
      function getTicket($user = '', $pass = '') {
         $error_message = '';
         $ccache = new KRB5CCache(); //init
         $ccache->setConfig( '/etc/krb5.conf' ); //default config for kerberos
         $princ = $user . '@' . $this->realm; //Construct principle from username and realm
         try {
            $ccache->initPassword( $princ, $pass );
         } catch ( Exception $e ) {
            $error_message = $e->getMessage();
         }
         $entries = $ccache->getEntries(); //returns the same as running `klist`
         if ( !sizeof( $entries ) > 0 ) { //If there's no ticket at position 0, there are no tickets!
            watchdog( 'user', 'Kerberos Principle Ticket Request failed for user %user realm %realm.  Error was: %error.', array(
                                                                                                                                '%user'   => $user,
                                                                                                                                '%realm'  => $this->realm,
                                                                                                                                '%error'  => $error_message
                                                                                                                           ) );
            return NULL;
         }
         else {
            return $entries;
         }

      }

   }
